#ifndef _init_h
#define _init_h

#include <solution.h>

class Init {
public:
  virtual void operator()(Solution & _solution) = 0;
};

/**
 *  Initialization to a random bit string
 *
 */
class RandomInit : public Init {
public:
/**
 *  Constructor
 *
 * @param _n size of the bit string
 */
  RandomInit(int _n) {
    n = _n;
  }

/**
 *  Initialization to a random bit string
 *
 * @param _n size of the bit string
 * @param _solution the solution to initialize
 */
  void operator()(Solution & _solution) {
    _solution.resize(n);

    for(unsigned int i = 0; i < n; i++) 
      _solution[i] = (random() % 2 == 1);  // random() % 2 donne 0 ou 1
  }

private:
  // size of the bitstring
  int n;
};



/**
 *  Initialization to the bit string O^N
 *
 */
class ZeroInit : public Init {
public:
/**
 *  Constructor
 *
 * @param _n size of the bit string
 */
  ZeroInit(int _n) {
    n = _n;
  }

/**
 *  Initialization to the bit string O^N
 *
 * @param _solution the solution to initialize
 */
  void operator()(Solution & _solution) {
    _solution.resize(n);

    for(unsigned int i = 0; i < n; i++) 
      _solution[i] = false;  
  }

private:
  // size of the bitstring
  int n;
};

#endif
