/**
 * 
 */
import java.io.*;
import java.util.Random;



/**
 * @author verel
 *
 */
public class Main {

    /**
     * @param args
     */
    public static void main(String[] args) {
	/***
	 * the parameters of the evolutionary algorithm
	 */

	// initialization of the random numbers sequence
	Random random;
	if (args.length == 1) 
	    random = new Random(Integer.parseInt(args[0]));
	else
	    random = new Random();

	// length of the bit strings
	int n = 1000;

	// Evaluation function (oneMax)
	OneMax eval = new OneMax(n);

	// population size of the parents
	int mu = 10;

	// population size of childrens
	int lambda = 50;

	// initialization method of solutions
	RandomInit initSol = new RandomInit(random, n);

	// tournament size for selection
	int tournamentSize = 2;

	// rates of crossOver and mutation
	double crossOverRate = 0.8;

	// rates of mutation
	double mutationRate = 1.0;
		
	// maximum number of generation
	int maxGeneration = 1000;

	/***
	 * the evolutionary algorithm
	 */

	// Evolutionary algorithm with all the parameters
	EvolutionaryAlgorithm ea = new EvolutionaryAlgorithm(random, eval, mu, lambda, initSol, tournamentSize, crossOverRate, mutationRate, maxGeneration);

	/***
	 * execution of the algorithm
	 */

	// the population
	Population population = new Population();

	// let's run !
	ea.run(population);

    }


}
